#TODO: Figure why contents must be wrapped with PARENTS[0]

from Cache import Cache
from OFS.DTMLDocument import DTMLDocument, default_dd_html
from Globals import HTML, HTMLFile, MessageDialog
from urllib import quote

manage_addCachedDocumentForm=HTMLFile('documentAdd', globals())

def manage_addCachedDocument(self, id, title='', file='', REQUEST=None, submit=None):
    """Add a DTML Document object with the contents of file. If
    'file' is empty, default document text is used.
    """
    if type(file) is not type(''): file=file.read()
    if not file: file=default_dd_html
    ob=CachedDocument(file, __name__=id)
    ob.title=title
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''

class CachedDocument(Cache, DTMLDocument):
    """ Cached DTML Document """
    meta_type = 'Cached DTML Document'
    
    #used when we're called from inside another DTML document
    __call__=Cache.__str__
    
    #used when we're called thorugh web
    index_html=Cache.__call__
    
    #donno, but it doesn't work without this :)
    __str__=DTMLDocument.__str__
    
    
    ##for debugging - returns data bypassing the cache 
    #realview=DTMLDocument.__call__
    
    def __init__(self, file, __name__=""):
        DTMLDocument.__init__(self, file, __name__=__name__)
        Cache.__init__(self)
        
    
    def _getData(self, client, REQUEST, args, kwargs):

        #I don't know how to pass the kwargs into DTMLDocument.__call__
        #since I need to turn a dict {'a' :3} into parameters:
        #   __call__(...., a=3)
        #So instead I pack them into REQUEST and hope that works
        
        for k in kwargs.keys():
            if not REQUEST.has_key(k): REQUEST[k] = kwargs[k]
        
        return DTMLDocument.__call__(self, client=client, REQUEST=REQUEST)
