from DateTime import DateTime
from Persistence import Persistent

class timed(Persistent):
    """ Expire at most every N seconds """

    def __init__(self, delay=3600):
        self.delay = delay
        self.nextExpireTime = DateTime().timeTime() + delay

    def hasExpired(self):
        now = DateTime().timeTime()
        if (now > self.nextExpireTime):
            return 1
        else:
            return 0

    def expireHeader(self):
        sendExpireHeader = 1
        return (sendExpireHeader, self.nextExpireTime)

    def doExpire(self, time):
        self.nextExpireTime = time + self.delay

    def manage_properties(self):
        pass

    def manage_propertiesForm(self):
        pass


class never(Persistent):
    """ never expire """
    
    def hasExpired(self):
        return 0

    def expireHeader(self):
        sendExpireHeader = 1
        nextExpireTime = DateTime.timeTime() + 14400
        return (sendExpireHeader, nextExpireTime)

    def doExpire(self, time):
        pass

    def manage_properties(self):
        pass

    def manage_propertiesForm(self):
        pass
